//+------------------------------------------------------------------+
//|                                                     MACDtest.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright ? 2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright ? 2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  RoyalBlue
#property  indicator_color2  Red
//#property  indicator_width1  2
//---- indicator parameters
extern int RSIPeriodMacd=14;
extern int RSIPeriodSignal=14;
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     RSIMacdBuffer[];
double     RSISignalBuffer[];
double     MacdBuffer[];
double     SignalBuffer[];
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
  // SetIndexDrawBegin(1,SignalSMA);//??
   //IndicatorDigits(Digits+1);//??
//---- indicator buffers mapping
   SetIndexBuffer(0,RSIMacdBuffer);
   SetIndexBuffer(1,RSISignalBuffer);
   SetIndexBuffer(2,MacdBuffer);
   SetIndexBuffer(3,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("RSI of MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
   SetIndexLabel(0,"RSIMACD");
   SetIndexLabel(1,"RSISignal");
    SetIndexLabel(2,"MACD");
   SetIndexLabel(3,"Signal");
   
   
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   for(i=limit; i>=0; i--)
     { MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);}
//---- signal line counted in the 2-nd buffer
   for(i=limit; i>=0; i--)
      {SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i);
      }
      //for(int i=0; i<limit; i++) 
        for(i=limit; i>=0; i--){RSIMacdBuffer[i] = iRSIOnArray(MacdBuffer,0,RSIPeriodMacd,i);}
      //for(int i=0; i<limit; i++) 
       for(i=limit; i>=0; i--) {RSISignalBuffer[i] = iRSIOnArray(SignalBuffer,0,RSIPeriodSignal,i);}
//---- done
   return(0);
  }
//+------------------------------------------------------------------+